import { system, world, EntityEquippableComponent, EquipmentSlot, ItemStack} from "@minecraft/server";
export function getScore(player, objective) {
	return world.scoreboard.getObjective(objective).getScore(player) ?? 0;
}
export function setScore(player, objective, score) {
	return world.scoreboard.getObjective(objective).setScore(player, score) ?? 0;
}
export function addScore(player, objective, score) {
	return world.scoreboard.getObjective(objective).addScore(player, score) ?? 0;
}
const w = world.getDimension("overworld");
world.afterEvents.entitySpawn.subscribe(use =>{
	let e = use.entity;
	if(e.typeId.includes("_wyvern_egg")){
		let nameTag = e.typeId.replace("_wyvern_egg", "")
		e.runCommandAsync("scoreboard objectives add egg_time dummy")
		e.runCommandAsync("scoreboard players set @s egg_time 20")
		e.addTag(`${nameTag}`)
	}
});
let wyverns_type = ["fire", "ice", "ground", "poison", "wither", "ender"]
system.runInterval(() =>{
	try{
		for(let p of world.getPlayers()){
			p.runCommandAsync("gamerule sendcommandfeedback false")
			if(p.hasTag("mount") && p.isJumping){
				p.runCommandAsync("effect @e[family=wyvern,r=4] levitation 1 5 true")
				p.runCommandAsync("event entity @e[family=wyvern,r=4] new:wyvern_can_fly")
			}
			if(!p.hasTag("mount")){
				p.runCommandAsync("event entity @e[family=wyvern,r=4] new:wyvern_not_can_fly")
			}

			for(let types of wyverns_type){
				let wyverns_egg = w.getEntities({type: `new:${types}_wyvern_egg`})
				for(let we of wyverns_egg){
					let egg_time = getScore(we, "egg_time");
					if(!we.hasTag("shaked")){
						if(egg_time == 10){
							we.runCommandAsync("event entity @s[tag=!shaked] new:egg_shaked")
							we.runCommandAsync("tag @s[tag=!shaked] add shaked")
						}
					}
					if(we.hasTag("shaked")){
						if(egg_time == 0){
							we.runCommandAsync("event entity @s[tag=shaked] new:egg_transform")
						}
					}
					let view = p.getEntitiesFromViewDirection({maxDistance: 7});
					view.forEach((look) => {
						let eggTag;
						let firstWord;
						let eggName;
						if(look.entity.typeId == we.typeId){
							look.entity.getTags().forEach(t => {
								if (t.startsWith('new:')) {
									eggTag = `${t.replace("new:", "").split(",")}`
									firstWord = t[4].toUpperCase();
									eggName = `${firstWord}`+`${eggTag.replace(`${t[4]}`, "")}`
									p.runCommandAsync(`title @s actionbar §7--${eggName} Wyvern Egg--\n§6Hatching Time: §b${getScore(look.entity, "egg_time")} min`);
								}
							}); 
						}
					});
				}
			}
		}
	}catch(e){

	};
})
system.runInterval(()=>{			
	for(let types of wyverns_type){
		let wyverns_egg = w.getEntities({type: `new:${types}_wyvern_egg`})
		for(let we of wyverns_egg){
			let egg_time = getScore(we, "egg_time");
			if(egg_time > 0){
				we.runCommandAsync(`scoreboard players remove @s egg_time 1`)
			}
		}
	}
}, 1200)